#ifndef fooconnectionhfoo
#define fooconnectionhfoo

#include <glib.h>
#include <linux/netfilter.h>
#include <libipq.h>

typedef enum verdict { VERDICT_ACCEPT, VERDICT_DROP, VERDICT_REJECT } verdict_t;

typedef enum conn_direction { DIR_INCOMING, DIR_OUTGOING, DIR_PASSING } conn_direction_t;

typedef struct conn_info {
    unsigned long id;
    conn_direction_t direction;
    gchar in_device[IFNAMSIZ+1];
    gchar out_device[IFNAMSIZ+1];
    guint32 src_ip_address, dst_ip_address;
    guint proto;
    guint16 port;
    guint8 icmp_type;
    long timestamp;
    gboolean broadcast;
    gchar* from_string;
    gchar* to_string;
    gchar* type_string;
    gchar* timestamp_string;
} conn_info_t;

void conn_new(ipq_packet_msg_t *ci);
void conn_verdict(verdict_t v);

#endif
