#!/bin/sh

reset() {
    iptables -D INPUT -j fieryfilter
    iptables -D OUTPUT -j fieryfilter_out
    iptables -D FORWARD -j fieryfilter  

    iptables -F fieryfilter
    iptables -X fieryfilter
    iptables -F fieryfilter_out
    iptables -X fieryfilter_out
}

create() {
    iptables -N fieryfilter
    iptables -A fieryfilter -s 127.0.0.0/8 -d 127.0.0.0/8 -j ACCEPT
    #iptables -A fieryfilter -m state --state INVALID -j DROP
    iptables -A fieryfilter -m state --state ESTABLISHED -j ACCEPT
    iptables -A fieryfilter -m state --state RELATED -j ACCEPT
    iptables -A fieryfilter -m state --state NEW -j QUEUE
    iptables -A fieryfilter -j ACCEPT

    iptables -N fieryfilter_out
    iptables -A fieryfilter_out -p icmp --icmp-type destination-unreachable -j ACCEPT

    grep nameserver /etc/resolv.conf | sed s/nameserver// | {
        while read ip ; do
            iptables -A fieryfilter_out -p udp --dport 53 -d $ip -j ACCEPT
        done
    }

    iptables -A fieryfilter_out -j fieryfilter
}

activate() {
    iptables -A INPUT -j fieryfilter
    iptables -A OUTPUT -j fieryfilter_out
    iptables -A FORWARD -j fieryfilter
}

modprobe iptable_filter
modprobe ip_queue
rm -f /tmp/fieryfilterd

reset 2> /dev/null
create
activate
sudo ./daemon/ffd

reset 2> /dev/null
